#include <stdio.h>
#include "Robert_PublicFile.h"


// ESP_LOGE(ADCTAG, "config scan response data failed, error code = %x", ret);

uint8_t write_data_buff[DATA_Lenth] = {0};

const uint16_t Near_threshold_Truth_table[11] =  {0x0C8,0x0D0,0x0E5,0x0EA,0x0f0,0x0ff,0x010A,0x014A,0x0151,0x016A,0x018A};//20210705测试完成，不漏人 未装梯验证
const unsigned char Near_Gear_CNT_table[11] = {22,4,4,3,3,3,4,5,5,5,5};  //20210705测试完成，不漏人 未装梯验证
const uint16_t Leave_threshold_Truth_table[20] = {0x00DC,0x011E,0x0147,0x0171,0x0186,0x019A,0x019A,0x019A,0x019A,0x019A,0x019A,0x019A,0x019A,0x019A,0x019A,0x019A,0x019A,0x019A,0x019A,0x019A};
uint8_t OUTPUT_ind =0x02;
uint8_t Sensor_ind =0x02;


uint8_t Gear = 5;        // 档位
uint16_t Keeptime = 2;   // 保持时间
uint8_t Direction = 0;   // 方向
uint8_t DeviceNameSet[20] = {0}; // 设备名称数据备份 存储时使用此数组内容
// char* TEST_DEVICE_NAME = "IMS5-BA2-";//设备名称

char RandStr[20] = "";
//char RandStr[20] = "B6T1 Lower left";
//char RandStr[20] = "B6T2 Lower right";
//char RandStr[20] = "B7T1 Upper left";
//char RandStr[20] = "B7T2 Upper right";

uint8_t writeFlg = 0;


uint8_t ConnectedFlag = 0;
// #define advertisingtime  6 //2min
uint32_t advertisingtimeCount = 0;
uint8_t advertisingFlag = 1;
uint8_t CloseFlg = 0;

uint16_t ADC_Counter = 0;   // ADC 采样次数 》3次后进行数据处理
uint16_t updateStatusTime=0;

uint16_t Near_threshold=0; 
uint16_t Leave_threshold=0;
int16_t I_buffer[3]={0,0,0};
int16_t Q_buffer[3]={0,0,0};
uint8_t I_level_Near=0;                        //I路信号电平
uint8_t Q_level_Near=0;                        //Q路信号电平
uint8_t I_fall_Near=0;                         //I路信号下降沿标志
uint8_t Q_fall_Near=0;                         //Q路信号下降沿标志
uint8_t I_level_Leave=0;                       //I路信号电平
uint8_t Q_level_Leave=0;                       //Q路信号电平
uint8_t I_fall_Leave=0;                       //I路信号下降沿标志
uint8_t Q_fall_Leave=0;                      //Q路信号下降沿标志
uint8_t Near_CNT=0;                          //靠近信号计数
uint8_t Near_Time=0;                          //靠近信号定时
uint8_t Near_Tx_update=0;                     //靠近
uint8_t Near_Tx_Time=0;                      //靠近
uint8_t Leave_CNT_A=0;                      //远离信号计数A
uint8_t Leave_CNT_B=0;                       //远离信号计数B
uint8_t Leave_Time_A=0;                      //远离信号定时A
uint8_t Leave_Time_B=0;                      //远离信号定时B
uint8_t Leave_Time_C=0;                      //远离信号定时C
uint8_t Leave_Time_D=0;                      //远离信号定时D
uint8_t Leave_Time_E=0;                      //远离信号定时E
uint8_t Leave_Tx_update=0;                   //远离
uint8_t Leave_Tx_Time=0;                      //远离  
uint8_t Near_L_CNT=0;                          //用远离门限计算靠近信号计数，用于清除远离信号误报的问题(低档位出现误报问题）
uint8_t Near_L_Time=0;                          //用远离门限计算靠近信号定时，用于清除远离信号误报的问题(低档位出现误报问题）            

/*----光耦继电器输出变量-----*/
uint8_t Output_Sign = 0;                   //
uint32_t Output_Time = 0;                      //

/*----LED_Sensor变量-----*/
uint8_t LED_Sensor_Time = 0;
uint8_t TX_time = 0;                            //用于定时200mS，发送数据

void Stop_All_ISR(void)
{
    timer_pause(TIMER_GROUP_0, TIMER_0);
}
void Start_All_ISR(void)
{
    timer_start(TIMER_GROUP_0, TIMER_0);
}

void IQhandle()
{
    I_buffer[ADC_Counter] = adc1_get_raw(I_Channal);
    Q_buffer[ADC_Counter] = adc1_get_raw(Q_Channal);
    // ESP_LOGE(ADCTAG, "adc tag : I_Data:0x%x       Q_Data:0x%x", I_buffer[ADC_Counter],Q_buffer[ADC_Counter]);
    ADC_Counter++;
    if(ADC_Counter < 3)
    {
        return;
    }
    ADC_Counter = 0;
 /**************** 
      用靠近档位判别靠近(Near_threshold) 
    *****************/
     if((I_buffer[0] < Near_threshold)&&(I_buffer[1] < Near_threshold)&&(I_buffer[2] < Near_threshold))
     {
       if(( I_fall_Near ==0 )&&(I_level_Near == 0))                                         //I下降沿正在发生
       {
         I_fall_Near =1;                                           //I下降沿正在发生,Q下降沿还未发生
         I_level_Near = 1;                                         //
         if((Q_fall_Near ==1)&&(Q_level_Near == 1))                       //Q下降沿早已发生并且为低电平,作靠近靠近处理
         {
           Q_fall_Near =0;                    //Q下降沿标志位清零
           //Q_level_Near = 0;//
           I_fall_Near =0;                    //I下降沿标志位清零
           //I_level_Near = 0;
           Near_CNT++;
           if(Near_CNT ==1)
           {
             Near_Time = 0;
           }
           if(Near_CNT >=1)
           {
               Near_L_Time = 0;
               Near_L_CNT = 0;
               Leave_CNT_A = 0;
               Leave_Time_A = 0;
               Leave_CNT_B = 0;
               Leave_Time_B = 0;
               Leave_Tx_update =0;
               Leave_Time_C = 0;
             if(Near_CNT >=Near_Gear_CNT_table[Gear])
             {
              //  ESP_LOGE(ADCTAG, "adc output tag : I_Data:0x%x       Q_Data:0x%x", I_buffer[0],Q_buffer[0]);
               Near_Tx_update = 2;
               Near_Time = 0;
               Near_CNT = 0;
             }
            /****************
             *****************/    
           }
         }
         else
         {
           //I_fall_Near =1;                                           //I下降沿正在发生,Q下降沿还未发生
           //I_level_Near = 1;                                         //
         }
       }
         
     }
     if((I_buffer[0] > Near_threshold)&&(I_buffer[1] >Near_threshold)&&(I_buffer[2] > Near_threshold))   //I上升沿正在发生或为高电平
     {
       I_fall_Near =0;                    //I下降沿标志位清零
       I_level_Near = 0;                  //
     }
     if((Q_buffer[0] < Near_threshold)&&(Q_buffer[1] < Near_threshold)&&(Q_buffer[2] < Near_threshold))
     {
       if(( Q_fall_Near ==0 )&&(Q_level_Near == 0))                                         //Q下降沿正在发生
       {
         Q_fall_Near =1;                                           //Q下降沿正在发生,I下降沿还未发生
         Q_level_Near = 1;
         /**************** 
         *****************/
       }
     }
     if((Q_buffer[0] > Near_threshold)&&(Q_buffer[1] >Near_threshold)&&(Q_buffer[2] > Near_threshold))   //Q上升沿正在发生或为高电平
     {
       Q_fall_Near =0;                    //Q下降沿标志位清零
       Q_level_Near = 0;                  //
     }
    /**************** 
      用远离档位判别靠近(Leave_threshold) 
    *****************/
     if((I_buffer[0] < Leave_threshold)&&(I_buffer[1] < Leave_threshold)&&(I_buffer[2] < Leave_threshold))
     {
       if(( I_fall_Leave ==0 )&&(I_level_Leave == 0))                                         //I下降沿正在发生
       {
         I_fall_Leave =1;                                           //I下降沿正在发生,Q下降沿还未发生
         I_level_Leave = 1;                                         //
         /**************** 
         *****************/
         if((Q_fall_Leave ==1)&&(Q_level_Leave == 1))                       //Q下降沿早已发生并且为低电平,作靠近靠近处理
         {
           Q_fall_Leave =0;                    //Q下降沿标志位清零
           //Q_level_Leave = 0;//
           I_fall_Leave =0;
           Near_L_CNT++;
           //GPIOA->ODR &= 0xF7;      //PA3上电输出低电平,蓝或绿灯亮灭 
           if(Near_L_CNT ==1)
           {
             Near_L_Time = 0;
             //GPIOA->ODR &= 0xF7;      //PA3上电输出低电平,蓝或绿灯亮灭
           }
           if(Near_L_CNT >=10)
           {
             Near_L_Time = 0;
             Near_L_CNT = 0;
             //GPIOA->ODR &= 0xF7;      //PA3上电输出低电平,蓝或绿灯亮灭
             //GPIOA->ODR |= 0x08;      //PA3上电输出高电平,蓝或绿灯亮
             Leave_CNT_A = 0;
             Leave_Time_A = 0;
             Leave_CNT_B = 0;
             Leave_Time_B = 0;
             Leave_Tx_update =0;
             Leave_Time_C = 0;
           }

         }
         else
         {
//          I_fall_Leave =1;                                           //I下降沿正在发生,Q下降沿还未发生
//          I_level_Leave = 1;                                         //
         }
       }
         
     }
     if((I_buffer[0] > Leave_threshold)&&(I_buffer[1] >Leave_threshold)&&(I_buffer[2] > Leave_threshold))   //I上升沿正在发生或为高电平
     {
       I_fall_Leave =0;                    //I下降沿标志位清零
       I_level_Leave = 0;                  //
     }
     if((Q_buffer[0] < Leave_threshold)&&(Q_buffer[1] < Leave_threshold)&&(Q_buffer[2] < Leave_threshold))
     {
       if(( Q_fall_Leave ==0 )&&(Q_level_Leave == 0))                                         //Q下降沿正在发生
       {
         Q_fall_Leave =1;                                           //Q下降沿正在发生,I下降沿还未发生
         Q_level_Leave = 1; 
         if((I_fall_Leave ==1)&&(I_level_Leave == 1))                       //I下降沿早已发生并且为低电平,作远离处理
         {
           I_fall_Leave =0;                    //I下降沿标志位清零
           //I_level_Leave = 0;                  // 
           Q_fall_Leave =0;                    //Q下降沿标志位清零
           //Q_level_Leave =0;
           Leave_CNT_A++;
           if(Leave_CNT_A ==1)
           {
             Leave_Time_A = 0;
           }
           if(Leave_CNT_A >=3)   //5
           {
             Leave_CNT_A = 0;
             Leave_Time_A = 0;
             Leave_CNT_B++;
             Near_CNT = 0;
             Near_Time = 0;
             Leave_Time_D = 0;
             Leave_Time_E = 0;
             if(Leave_CNT_B ==1)
             {
               Leave_Time_B = 0;
             }
             if(Leave_CNT_B >=8)     //3
             {
               Near_L_Time = 0;
               Near_L_CNT = 0;
               Leave_CNT_B = 6;
               if(Leave_Tx_update==0)
               {
                 Leave_Tx_update =2;
//                 Leave_Tx_update =0;
                 Leave_Time_C =0;
               }
             }
           } 
         }
         else
         {
//               Q_fall_Leave =1;                                           //Q下降沿正在发生,I下降沿还未发生
//               Q_level_Leave = 1; 
         }
       }
     }
     if((Q_buffer[0] > Leave_threshold)&&(Q_buffer[1] >Leave_threshold)&&(Q_buffer[2] > Leave_threshold))   //Q上升沿正在发生或为高电平
     {
       Q_fall_Leave =0;                    //Q下降沿标志位清零
       Q_level_Leave = 0;                  //
     }
    ADC_Counter = 0;
}

void mainloop()
{
  if((Near_Tx_Time >=2)&&(Near_Tx_update)&&(Leave_Tx_Time >=2)&&(TX_time >=2))                 //发送靠近给阻尼板接收
  {
     if(Near_Tx_update ==1)
    {
      //UART1_TX1(0x01,Gear);
      Near_Tx_update = 0;
      Near_Tx_Time = 0;
      //Leave_Time_C =0;
      //Leave_Tx_update =0;
      //GPIOD->ODR &= 0xEF;      //PD4上电输出低电平,红灯灭
      //GPIOA->ODR |= 0x08;      //PA3上电输出高电平,蓝或绿灯亮
    }
    if(Near_Tx_update ==2)
    {
      //UART1_TX1(0x01,Gear);
      Near_Tx_update --;
      Near_Tx_Time = 0;
      Leave_Time_C =0;
      Leave_Tx_update =0;
      //GPIOD->ODR &= 0xEF;      //PD4上电输出低电平,红灯灭
      //GPIOA->ODR |= 0x08;      //PA3上电输出高电平,蓝或绿灯亮
      Output_Sign = 1;                  //wilson 
      Output_Time = 0;//wilson
      //GPIOC->ODR |= 0x40;                   //PC6输出高电平,光耦继电器闭合。
      OUTPUT_H();   //wilson  //2019.11.13 修改 output NC
      ESP_LOGE(MAIN_LOG,"near signal out!!");
    }  
  }
  if((Leave_Time_C >=80)&&(Leave_Tx_Time >=2)&&(Near_Tx_Time >=2)&&(TX_time >=2))                 //发送远离给阻尼板接收
  {
    if((Leave_Tx_update ==1)&&(Leave_Time_C >=90))
    {
      //UART1_TX1(0x02,Gear);
      Leave_Time_C =0;
      Leave_Tx_update =0;
      Leave_Tx_Time =0;
      
    }
    if(Leave_Tx_update ==2)
    {
      //UART1_TX1(0x02,Gear);
      Leave_Tx_Time =0;
      Leave_Time_C =0;
      Leave_Tx_Time =0;
      //GPIOA->ODR &= 0xF7;      //PA3上电输出低电平,蓝或绿灯亮灭
      //GPIOD->ODR |= 0x10;      //PD4上电输出高电平,红灯亮
      Leave_Tx_update --;
      Output_Sign = 1;                  //wilson 
      Output_Time = 0;//wilson
      OUTPUT_H();
      ESP_LOGE(MAIN_LOG,"leave signal out!!");
    } 
  }
  if((Near_Tx_Time >=50)&&(Leave_Tx_Time >=50)&&(TX_time >=50))                 //发送无物体给阻尼板接收
  {
    //UART1_TX1(0,Gear);
    TX_time = 0;
    
  }
}

void threshold_Init()
{
  Near_threshold = Near_threshold_Truth_table[Gear];
  Leave_threshold = Leave_threshold_Truth_table[Gear];
  ESP_LOGE(ADCTAG, "adc tag : Near_threshold:%x    Leave_threshold:%x", Near_threshold,Leave_threshold);
}

void OUTPUT_L()
{
//   nrf_gpio_pin_set(LED_Output);
//   nrf_gpio_pin_set(SSR);
    LED_Output_L();
    SSR_Output_L();
    OUTPUT_ind = 0x01;
    Sensor_ind = 0x01;
}

void OUTPUT_H()
{
//   nrf_gpio_pin_clear(LED_Output);
//   nrf_gpio_pin_clear(SSR);
    LED_Output_H();
    SSR_Output_H();
    OUTPUT_ind = 0x02;
    Sensor_ind = 0x02;
}





