#ifndef _ROBERT_GPIO_H
#define _ROBERT_GPIO_H

#include <stdio.h>
#include "driver/gpio.h"
#include "freertos/FreeRTOS.h"
#include "freertos/task.h"
#include "Robert_PublicFile.h"

#define Robert_delayMs(x) vTaskDelay(x)
#define Robert_delayUs(x) usleep(x)

#define SSR_Output 1
#define LED_Sensor 11
#define LED_Output 18


#define OUTPUT_Pins ((1ULL<<SSR_Output) | (1ULL<<LED_Sensor) | (1ULL<<LED_Output))//(1<<LED_Sensor)|(1<<LED_Output)//(1<<SSR_Output)|(1<<LED_Sensor)|(1<<LED_Output)

#define SSR_Output_H() gpio_set_level(SSR_Output,1)
#define SSR_Output_L() gpio_set_level(SSR_Output,0)
#define LED_Sensor_H() gpio_set_level(LED_Sensor,1)
#define LED_Sensor_L() gpio_set_level(LED_Sensor,0)
#define LED_Output_H() gpio_set_level(LED_Output,1)
#define LED_Output_L() gpio_set_level(LED_Output,0)

void Robert_gpio_Init(void);



#endif
