/*
   雷达传感器备选方案程序：esp32c3
        2021-10 ： QSR
        当前为蓝牙数据传输以及数据存储10-29
        当前实验更改蓝牙名称
*/

/****************************************************************************
*
* This demo showcases BLE GATT server. It can send adv data, be connected by client.
* Run the gatt_client demo, the client demo will automatically connect to the gatt_server demo.
* Client demo will enable gatt_server's notify after connection. The two devices will then exchange
* data.
*
****************************************************************************/


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "freertos/FreeRTOS.h"
#include "freertos/task.h"
#include "freertos/event_groups.h"
#include "esp_system.h"
#include "esp_log.h"

#include "Robert_PublicFile.h"


uint8_t finish_Buf[6] = {0xAA,0x55,0x02,0x01,0x03};
char test[13] = "AABB";
uint8_t testBuff[5] = {0x00};
uint8_t testBuff1[5] = {0x00,0x01,0x02,0x03,0x04};
void app_main(void)
{
    // char test1[30] = {0};
    Robert_gpio_Init();
    single_read_Init(NULL);
    Robert_NVS_Init();
    LED_Output_L();
    LED_Sensor_L();    
    // nvs_write_data_to_flash(&testBuff);
    nvs_read_data_from_flash();
    // Gear = 5;
    threshold_Init();
    Robert_BLE_Init();
    // LED_Output_H();
    // LED_Sensor_H();
    timer_user_Init();
    // esp_ble_gap_stop_advertising();
    while (1)
    {
        mainloop();
        // ESP_LOGE(MAIN_LOG, "timerDeal:%d  testTimerhandle:%d",testTimerDeal,testTimerhandle);
        // ESP_LOGE(ADCTAG, "adc tag : I_Data:0x%x       Q_Data:0x%x", I_buffer[0],Q_buffer[0]);
        // IQhandle();
        /* code */
        if(writeFlg == 1)
        {
            writeFlg = 0;
            ESP_LOGE(MAIN_LOG,"开始保存数据！");
            Robert_writeFlash();
            ESP_LOGE(MAIN_LOG,"保存数据完成！");
            Robert_ble_SendData(&finish_Buf,6);
        }
        // vTaskDelay(10/portTICK_RATE_MS);
    }
    
}
