#ifndef _ROBERT_TIMER_H
#define _ROBERT_TIMER_H

#include <stdio.h>
#include "freertos/FreeRTOS.h"
#include "freertos/task.h"
#include "freertos/queue.h"
#include "driver/timer.h"
#include "Robert_PublicFile.h"

#define TIMER_DIVIDER         (16)  //  Hardware timer clock divider
#define TIMER_SCALE          (TIMER_BASE_CLK / (TIMER_DIVIDER*500))  // 5*TIMER_SCALE 1ms    3*TIMER_SCALE  
// #define TIMER_SCALE          (TIMER_BASE_CLK / (TIMER_DIVIDER*50))  // 5*TIMER_SCALE 10ms    


extern int testTimerDeal;
extern int testTimerhandle;

void example_tg_timer_init(int group, int timer, bool auto_reload, int timer_interval_sec);
void timer_user_Init();
void timer_Deal();
#endif
